using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace StopWatch
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button button1;
    
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button1 = new System.Windows.Forms.Button();
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(112, 168);
            this.button1.Size = new System.Drawing.Size(264, 120);
            this.button1.Text = "button1";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.Controls.Add(this.button1);
            this.Text = "Form1";

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void button1_Click(object sender, System.EventArgs e)
        {
            StopWatch timer = new StopWatch();

            timer.Start();
            Thread.Sleep(1000);
            long elapseTime = timer.Stop();

            MessageBox.Show("The stop watch recorded " + elapseTime + "ms");

        }
	}

    public sealed class StopWatch
    {
        // Native Methods
        [DllImport("coredll.dll")]
        public static extern bool QueryPerformanceCounter(out long c);		
        [DllImport("coredll.dll")]
        public static extern bool QueryPerformanceFrequency(out long c);
  
        // Static data
        static long frequency;
        static bool perfCounterSupported;
  
        // Instance Data
        long startTime = 0;

        // Initialize the counter frequency static 
        static StopWatch()
        {
            perfCounterSupported = QueryPerformanceFrequency (out frequency);    
        }

        // Start the StopWatch
        public void Start()
        {
            startTime = TickCount;
        }

        // Stop the StopWatch
        public long Stop()
        {
            if(perfCounterSupported)
                return (long)((float)(TickCount - startTime) / frequency ) * 1000; 
            else
                return (TickCount - startTime);
        }

        // Get the current tick count
        public static long TickCount
        {
            get 
            {	
                long val;
                bool perfCounterSupported = QueryPerformanceCounter(out val);
				
                if (perfCounterSupported)	
                    return val;
                else				
                    return (long)System.Environment.TickCount;				
            }	
        }
    }

}
